import "Turbine.UI";
import "Turbine.Gameplay"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement

sharingWidth=114
sharingHeight=50
sharingWindow=Turbine.UI.Window()
sharingWindow:SetText("Kinsharing")
sharingWindow:SetSize(sharingWidth,sharingHeight)
if data["Options"] ~= nil then
	if data["Options"]["tbx"] ~= nil and data["Options"]["tby"] ~= nil then
		sharingWindow:SetPosition(tonumber(data["Options"]["tbx"]),tonumber(data["Options"]["tby"]))
	else
		sharingWindow:SetPosition(100,100)
	end
else
	sharingWindow:SetPosition(100,100)
end

sharingWindow:SetBackColor(Turbine.UI.Color(1,0,0,0))
sharingWindow:SetVisible(true)

sharingWindow.OpenButton=Turbine.UI.Lotro.Quickslot();
sharingWindow.OpenButton:SetParent(sharingWindow);
sharingWindow.OpenButton:SetSize(64,64);
sharingWindow.OpenButton:SetStretchMode(2);
sharingWindow.OpenButton:SetSize(24,24);


sharingWindow.Button3=Turbine.UI.Button(); -- create a label control to display our message
sharingWindow.Button3:SetParent(sharingWindow); -- sets the label as a child of the main window
sharingWindow.Button3:SetText(""); -- sets the actual message text
sharingWindow.Button3:SetPosition(0,0); -- places the message control in the vertical middle of the window with a 10 pixel left and right border
sharingWindow.Button3:SetSize(16,16); -- sets the message size
sharingWindow.Button3:SetStretchMode(1);
sharingWindow.Button3:SetSize(22,22); -- sets the message size

sharingWindow.Button3:SetBackground(0x4101e50c); 

sharingWindow.Button3.MouseClick=function()
	startTime=Turbine.Engine.GetLocalTime()
	sharingWindow.Button3:SetWantsUpdates(not sharingWindow.Button3:GetWantsUpdates())
	if data["Options"]==nil then
		data["Options"]={}
	end
	data["Options"]["tby"]=tostring(math.ceil(sharingWindow:GetTop()))
	data["Options"]["tbx"]=tostring(math.ceil(sharingWindow:GetLeft()))
	Turbine.PluginData.Save(Turbine.DataScope.Character, "KinCalendar", data);

end


sharingWindow.Button3.Update=function()
	if minimised then

		sharingWindow.Button3:SetWantsUpdates(false)
		minimised=false
	elseif Turbine.Engine.GetLocalTime()-startTime > 0.2 then
		local x = nil
		local y = nil
		local relx= nil
		local rely =nil
		x,y=sharingWindow:GetPosition()
		relx,rely=sharingWindow:GetMousePosition()

		sharingWindow:SetPosition(x+relx-5,y+rely-5)
	end
end


	



sharingWindow.OpenButton:SetPosition(25,5); --yeah, I got lazy and hardcoded the left side ;)
sharingWindow.OpenButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,""))
sharingWindow.OpenButton.ShortcutData=""; --save the alias text for later
sharingWindow.OpenButton:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
sharingWindow.OpenButton.DragDrop=function()
    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
    sc:SetData(sharingWindow.OpenButton.ShortcutData);
    sharingWindow.OpenButton:SetShortcut(sc);
end

sharingWindow.OpenButton.Bg=Turbine.UI.Control();
sharingWindow.OpenButton.Bg:SetParent(sharingWindow);
--sharingWindow.OpenButton.Bg:SetSize(sharingWindow.OpenButton:GetSize());
sharingWindow.OpenButton.Bg:SetPosition(sharingWindow.OpenButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
sharingWindow.OpenButton.Bg:SetZOrder(sharingWindow.OpenButton:GetZOrder()+1); -- force the icon to be displayed above the quickslot
sharingWindow.OpenButton.Bg:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
--sharingWindow.OpenButton.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display
sharingWindow.OpenButton.Bg:SetBackColor(Turbine.UI.Color(1,0,0,0));

sharingWindow.OpenButton.Bg:SetSize(64,64);
sharingWindow.OpenButton.Bg:SetStretchMode(1);
sharingWindow.OpenButton.Bg:SetSize(32,32);

sharingWindow.OpenButton.Icon=Turbine.UI.Control();
sharingWindow.OpenButton.Icon:SetParent(sharingWindow);
--sharingWindow.OpenButton.Icon:SetSize(sharingWindow.OpenButton:GetSize());
sharingWindow.OpenButton.Icon:SetPosition(sharingWindow.OpenButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
sharingWindow.OpenButton.Icon:SetZOrder(sharingWindow.OpenButton:GetZOrder()+5); -- force the icon to be displayed above the quickslot
sharingWindow.OpenButton.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
--sharingWindow.OpenButton.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display
sharingWindow.OpenButton.Icon:SetSize(64,64);
sharingWindow.OpenButton.Icon:SetStretchMode(1);
sharingWindow.OpenButton.Icon:SetSize(42,42);





-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon
sharingWindow.OpenButton.Icon:SetBackground(0x4113f505) --0x4113f51a

sharingWindow.OpenButton.MouseEnter=function()
    sharingWindow.OpenButton.Icon:SetBackground(0x4113f518)
end
sharingWindow.OpenButton.MouseLeave=function()
	sharingWindow.OpenButton.Icon:SetBackground(0x4113f505)

end
sharingWindow.OpenButton.MouseDown=function()
	sharingWindow.OpenButton.Icon:SetBackground(0x4113f617)
	
	
end
sharingWindow.OpenButton.MouseUp=function()
	sharingWindow.OpenButton.Icon:SetBackground(0x4113f518)
end

sharingWindow.OpenButton.MouseClick=function()
	calendarWindow:SetVisible(true)
	sharingWindow.OpenButton:SetWantsUpdates(true)
	openUD=true
end
openUD=true
sharingWindow.OpenButton.Update=function()
	if openUD then
		sharingWindow.OpenButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,""))
		sharingWindow.OpenButton:SetWantsUpdates(false)	
		openUD=false
	end
	--print("ud")
end

setOpenQS=function()
	local openQS="/1/"
	for i in pairs(data["Recents"]) do
		openQS=openQS.."/"..data["Recents"][i]..i.."/"
	end
	openQS="/"..data["Channel"].." "..encode({["Type"]="BasicRequest",["Version"]=version,["IDs"]=openQS})
	--print(openQS)
	sharingWindow.OpenButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,openQS))
	sharingWindow.OpenButton.ShortcutData=openQS; 
end

setOpenQS()




sharingWindow.ShareButton=Turbine.UI.Lotro.Quickslot();
sharingWindow.ShareButton:SetParent(sharingWindow);
sharingWindow.ShareButton:SetSize(64,64);
sharingWindow.ShareButton:SetStretchMode(2);
sharingWindow.ShareButton:SetSize(24,24);

	



sharingWindow.ShareButton:SetPosition(69,5); --yeah, I got lazy and hardcoded the left side ;)
sharingWindow.ShareButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,""))
sharingWindow.ShareButton.ShortcutData=""; --save the alias text for later
sharingWindow.ShareButton:SetAllowDrop(false); -- turn off drag and drop so the user doesn't accidentally modify our button action
sharingWindow.ShareButton.DragDrop=function()
    -- even though we turned off drop operations, there is a bug that allows the quickslot to drop on itself effectively wiping out the shortcut
    local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
    sc:SetData(sharingWindow.ShareButton.ShortcutData);
    sharingWindow.ShareButton:SetShortcut(sc);
end

sharingWindow.ShareButton.Bg=Turbine.UI.Control();
sharingWindow.ShareButton.Bg:SetParent(sharingWindow);
--sharingWindow.ShareButton.Bg:SetSize(sharingWindow.ShareButton:GetSize());
sharingWindow.ShareButton.Bg:SetPosition(sharingWindow.ShareButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
sharingWindow.ShareButton.Bg:SetZOrder(sharingWindow.ShareButton:GetZOrder()+1); -- force the icon to be displayed above the quickslot
sharingWindow.ShareButton.Bg:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
--sharingWindow.ShareButton.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display
sharingWindow.ShareButton.Bg:SetBackColor(Turbine.UI.Color(1,0,0,0));

sharingWindow.ShareButton.Bg:SetSize(64,64);
sharingWindow.ShareButton.Bg:SetStretchMode(1);
sharingWindow.ShareButton.Bg:SetSize(32,32);

sharingWindow.ShareButton.Icon=Turbine.UI.Control();
sharingWindow.ShareButton.Icon:SetParent(sharingWindow);
--sharingWindow.ShareButton.Icon:SetSize(sharingWindow.ShareButton:GetSize());
sharingWindow.ShareButton.Icon:SetPosition(sharingWindow.ShareButton:GetPosition()); --yeah, I got lazy and hardcoded the left side ;)
sharingWindow.ShareButton.Icon:SetZOrder(sharingWindow.ShareButton:GetZOrder()+5); -- force the icon to be displayed above the quickslot
sharingWindow.ShareButton.Icon:SetMouseVisible(false); -- prevent the icon from interacting with the mouse so that all mouse events fall through to the quickslot behind it
--sharingWindow.ShareButton.Icon:SetBlendMode(Turbine.UI.BlendMode.Overlay); -- this will cause any transparent parts of the background image to display your window's background instead of being completely transparent and displaying the game UI display
sharingWindow.ShareButton.Icon:SetSize(64,64);
sharingWindow.ShareButton.Icon:SetStretchMode(1);
sharingWindow.ShareButton.Icon:SetSize(42,42);

sharingWindow.ShareButton.Icon:SetBackground(0x4113f556) --0x4113f51a


shareBasicData=function()
	sharingWindow.ShareButton.Icon:SetBackground(0x4113f616)
	shareList={}
	for i in pairs(data["Other"]) do
		local a,b,c = string.match(i,"(%d+)%/(%d+)%/(%d+)")
		--print(currentValue)
		--print(c+b/100+a/10000)
		if c+b/100+a/10000 > currentValue then
			for j in pairs(data["Other"][i]) do
				shareList[#shareList+1]=data["Other"][i][j]
			end
		end
	end
	--Turbine.PluginData.Save(Turbine.DataScope.Character, "KinCalendarTest", shareList);
	local swaps = 1
	while swaps ~= 0 do
		swaps=0
		for i=2,#shareList do
			if string.match(shareList[i-1]["ID"],"^(%d+)") > string.match(shareList[i]["ID"],"^(%d+)") then
				local holding = shareList[i-1]
				shareList[i-1]=shareList[i]
				shareList[i]=holding
				swaps=swaps+1
			end
		end
	end
	--Turbine.PluginData.Save(Turbine.DataScope.Character, "KinCalendarTest2", shareList);
	for i =1,#shareList do
		shareList[i]=encode(shareList[i])
	end
	--Turbine.PluginData.Save(Turbine.DataScope.Character, "KinCalendarTest3", shareList);
	sharingWindow.ShareButton:SetWantsUpdates(true)
	sharingWindow:SetWantsUpdates(true)

	wantsUD=true



			
end





-- this is the code that handles the background, note that the handles are assigned to the quickslot but they manipulate the icon


sharingWindow.ShareButton.MouseClick=function()
	sharingWindow.ShareButton:SetWantsUpdates(true)
	sharingWindow:SetWantsUpdates(true)
	wantsUD=true
end
wantsUD=true
sharingWindow.Update=function()
	if wantsUD == false then
		sharingWindow:SetWantsUpdates(false)
		sharingWindow.ShareButton:SetWantsUpdates(false)

	end
end
sharingWindow.ShareButton.Update=function()
	if wantsUD then
		local shortcut =""
		for i=1,#shareList do
			
			if #(shortcut..shareList[i]) < 1900 and shareList[i] ~= "nil" then
				shortcut=shortcut..shareList[i]
				shareList[i]="nil"
			end
		end
		if shortcut == "" then
			sharingWindow.ShareButton.Icon:SetBackground(0x4113f556) 
			sharingWindow.ShareButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,""))
		else
			sharingWindow.ShareButton:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"/"..data["Channel"].." "..shortcut))
		end
		sharingWindow.ShareButton:SetWantsUpdates(false)	
		wantsUD=false
	end

	
end

	
sharingWindow:SetVisible(true)

--shareBasicData()	
--sharingWindow.ShareButton:SetWantsUpdates(false)	
shareList={}

